;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;		Часы	вер. 1.01
;; Intro (c)		создан: 20‎.11.‎2022		изменён: 3‎.12.‎2022
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

.386
.model flat,stdcall
option casemap:none
include G:\masm32\include\windows.inc
include G:\masm32\include\user32.inc
include G:\masm32\include\kernel32.inc
include G:\masm32\include\gdi32.inc
includelib G:\masm32\lib\user32.lib
includelib G:\masm32\lib\kernel32.lib
includelib G:\masm32\lib\gdi32.lib
include msvcrt.inc
include macros.asm

;
FormWidth			= 224
FormHeight			= 92
IndicatorWidth		= 210
IndicatorHeight		= 70
BtnMinimiX			= FormWidth-30
BtnMinimiY			= 2
BtnMinimiWidth		= 14
BtnMinimiHeight		= 12
BtnCloseX			= FormWidth-16
BtnCloseY			= 2
BtnCloseWidth		= 14
BtnCloseHeight		= 12
colon_sWidth		= 10
colon_x				= 1
colon_y1			= 12
colon_y2			= 30
IndicatorX			= (FormWidth-IndicatorWidth-2)/2
IndicatorY			= 15
color_indicator_hi	= 0000FF00h	;RGB(0x00, 0xFF, 0x00)
bk_color_indicator	= 00285100h	;RGB(0x00, 0x51, 0x28)

;структура задаёт битмапы сегментов в атласе
sBitMapAtlas struct; (sizeof=24, align=4)
	pos					POINT <>			;0	коор. сегмента
	atl					POINT <>			;8	коор. сегмента в атласе
	iWidth				sdword ?			;16	ширина сегмента
	iHeight				sdword ?			;20	высота сегмента
sBitMapAtlas ends
;структура 7-ми сегментного индикатора
s7segments struct; (sizeof=224, align=4)
;	fon					POINT <>				; 0		фон
;	sWidth	 			sdword ?				; 8		ширина
;	sHeight	 			sdword ?				; 12	высота
;	dp					sBitMapAtlas <>			; 16	точка
	segm				sBitMapAtlas 7 dup (<>)	; 40	сегменты
	segments7			byte 16 dup (?)			; 208
s7segments ends

;флаги главного окна! 
WS_MAIN_FORM	= WS_POPUP or WS_VISIBLE or WS_MINIMIZEBOX
MS_BASE_LABEL	= WS_CHILD or WS_VISIBLE or SS_BITMAP

;ID'шники контролов
MAIN_FORM_ID		= 0
BTN_MINIMI_ID		= 1
BTN_CLOSE_ID		= 2
DISPLAY_ID			= 3
TIMER_ID			= 4

.const
ClassName			db "MainForm", 0	;Watch
aButton				db "button", 0
aStatic				db "static", 0
aTextClose			db "X", 0
aTextMinimi			db "-", 0
aDisplay			db "DISPLAY", 0

;Segment7
Segment7_fon_x		= 6
Segment7_fon_y		= 29
Segment7_sWidth		= 30
Segment7_sHeight	= 50
Segment7_dp_rx		= 0
Segment7_dp_ry		= 29
Segment7_dp_rWidth	= 6
Segment7_dp_rHeight	= 6
align 4
Segment7			s7segments	 {\
	<\
		< <  6,  3 >, < 0,  0 >, 15, 4  >,\
		< < 19,  6 >, < 4, 12 >,  4, 17 >,\
		< < 19, 26 >, <12, 12 >,  4, 17 >,\
		< <  6, 41 >, < 0,  8 >, 14, 4  >,\
		< <  3, 25 >, < 8, 12 >,  4, 17 >,\
		< <  3,  6 >, < 0, 12 >,  4, 17 >,\
		< <  7, 22 >, < 0,  4 >, 13, 4  >\
	>,\
	<\
	00111111b, 00000110b, 01011011b, 01001111b, 01100110b, 01101101b, 01111101b, 00000111b,\
	01111111b, 01101111b, 01000000b, 00111000b, 00111001b, 00110001b, 01111001b, 00000000b \
	>\
};     '0'        '1'        '2'        '3'        '4'        '5'        '6'        '7'
;      '8'        '9'        '-'        'L'        'C'        'Г'        'E'        ' '

;
BitmapWidth 	= 16;
BitmapHeight	= 35;
align 4
BitmapSegments	byte 00111111b,11111000b	;0	;[35][2] = {
				byte 11111111b,11111110b	;1
				byte 01111111b,11111100b	;2
				byte 00111111b,11111000b	;3
				byte 01111111b,11100000b	;4
				byte 11111111b,11110000b	;5
				byte 11111111b,11110000b	;6
				byte 01111111b,11100000b	;7
				byte 00111111b,11110000b	;8
				byte 01111111b,11111000b	;9
				byte 11111111b,11111100b	;10
				byte 00111111b,11110000b	;11
				byte 01000001b,01000010b	;12
				byte 11100011b,11100111b	;13
				byte 11110111b,11111111b	;14
				byte 11111111b,11111111b	;15
				byte 11111111b,11111111b	;16
				byte 11111111b,11111111b	;17
				byte 11111111b,11111111b	;18
				byte 11111111b,11111111b	;19
				byte 11111111b,11111111b	;20
				byte 11111111b,11111111b	;21
				byte 11111111b,11111111b	;22
				byte 11111111b,11111111b	;23
				byte 11111111b,11111111b	;24
				byte 11111111b,11111111b	;25
				byte 11111111b,11110110b	;26
				byte 11100111b,11100010b	;27
				byte 01000010b,01000000b	;28
				byte 00110000b,00000000b	;29
				byte 01111000b,00000000b	;30
				byte 11111100b,00000000b	;31
				byte 11111100b,00000000b	;32
				byte 01111000b,00000000b	;33
				byte 00110000b,00000000b	;34
;}

.data?
hInstance			HINSTANCE ?
hIndicator			HWND ?
hBtnMinimi			HWND ?
hBtnClose			HWND ?	
hdNumbers			HWND 6 dup (?)
bmNumbers			HBITMAP 16 dup (?)
BitmapSegments2		dword BitmapHeight*BitmapWidth dup (?)

.code
WinMain proc hInst:HINSTANCE, hPrevInst:HINSTANCE, CmdLine:LPSTR, CmdShow:DWORD
local wc:WNDCLASSEX, msg:MSG
;edi -	hWnd:HWND
	lea		esi, wc
	ASSUME	esi:ptr WNDCLASSEX, edi:ptr MSG
	mov		[esi].cbSize, sizeof WNDCLASSEX
	mov		[esi].style, CS_BYTEALIGNCLIENT
	mov		[esi].lpfnWndProc, offset WndProc
	mov		[esi].cbClsExtra, NULL
	mov		[esi].cbWndExtra, NULL
	mov		eax, hInst
	mov		[esi].hInstance, eax
	mov		hInstance, eax
	mov		[esi].hbrBackground, CreateSolidBrush(00313031h) ;COLOR_MENUTEXT;COLOR_GRAYTEXT	;RGB(49, 48, 49);COLOR_BTNFACE+1
	mov		[esi].lpszClassName, offset ClassName
	mov		[esi].hIcon, LoadIcon(NULL, IDI_APPLICATION)
	mov		[esi].hIconSm, eax
	mov		[esi].hCursor, LoadCursor(NULL, IDC_ARROW)
	RegisterClassEx(esi)
	mov		ebx, CreateWindowEx(0,&ClassName,NULL,WS_MAIN_FORM,500,100,FormWidth,FormHeight,0,MAIN_FORM_ID,hInst,0)
	ShowWindow(ebx, SW_SHOWNORMAL)
	UpdateWindow(ebx)
	lea		edi, msg
	.while (true)
		GetMessage(edi, 0, 0, 0)
		.break .if (!eax)
		TranslateMessage(edi)
		DispatchMessage(edi)
	.endw
 	mov		eax, [edi].wParam
	ASSUME	esi:nothing, edi:nothing
	ret
WinMain endp

align_proc
UpdateTime proc
local time:SYSTEMTIME, Indicator[2]:byte
	GetLocalTime(&time)
	lea		edi, time.wHour
	.for (esi=0: esi<6: edi+=2)
		mov		cl, 10
		mov		ax, [edi]
		div		cl
		.if (al==0 && esi==0)
			mov		al, 15
		.endif
		mov		Indicator[0], al
		mov		Indicator[1], ah
		xor		ebx, ebx
		.repeat
			movzx	ecx, Indicator[ebx]
			SendMessage(hdNumbers[esi*4], STM_SETIMAGE, IMAGE_BITMAP, bmNumbers[ecx*4])
			inc		esi
			inc		ebx
		.until (ebx>=2)
	.endfor
	ret
UpdateTime endp

align_proc
WndProc proc uses esi edi ebx hWnd:HWND, uMsg:UINT, wParam:WPARAM, lParam:LPARAM
local image:HBITMAP, bmTemp:HBITMAP, buttDC:HDC, imageDC0:HDC
local tmpHGDIOBJ0:HGDIOBJ, tmpHGDIOBJ1:HGDIOBJ, tmpHGDIOBJ2:HGDIOBJ
	.if (uMsg == WM_TIMER)
		UpdateTime()
	.elseif (uMsg == WM_DESTROY)
		KillTimer(hWnd, TIMER_ID)
		PostQuitMessage(NULL)
	.elseif (uMsg == WM_CREATE)
		;//создать кнопку сворачивания и закрытия формы
		mov		hBtnMinimi, CreateWindowEx(0, &aButton, &aTextMinimi, WS_CHILD + WS_VISIBLE, BtnMinimiX,BtnMinimiY,BtnMinimiWidth,BtnMinimiHeight, hWnd, BTN_MINIMI_ID, hInstance, 0);"-"
		mov		hBtnClose, CreateWindowEx(0, &aButton, &aTextClose, WS_CHILD + WS_VISIBLE, BtnCloseX,BtnCloseY,BtnCloseWidth,BtnCloseHeight, hWnd, BTN_CLOSE_ID, hInstance, 0);"X"
		mov		hIndicator, CreateWindowEx(0, &aStatic, NULL, MS_BASE_LABEL + WS_BORDER, IndicatorX, IndicatorY, IndicatorWidth, IndicatorHeight, hWnd, DISPLAY_ID, hInstance, 0)
		disp_x	= (IndicatorWidth - (Segment7_sWidth*6+colon_sWidth*2))/2
		IF disp_x LT 0;<0
			disp_x	= 0
		ENDIF
		disp_y	= (IndicatorHeight - Segment7_sHeight)/2
		IF disp_y LT 0;<0
			disp_y	= 0
		ENDIF
		.for (edi=0, ebx=disp_x: edi<6: edi++)
			mov		hdNumbers[edi*4], CreateWindowEx(0, &aStatic, NULL, MS_BASE_LABEL, ebx, disp_y, Segment7_sWidth, Segment7_sHeight, hIndicator, edi, hInstance, 0)
			add		ebx, Segment7_sWidth
			.if (edi & 1)
				add		ebx, colon_sWidth
			.endif
		.endfor
		;//создать битмапы сегментов цифры
		mov		ebx, CreateDC(&aDisplay, NULL, NULL, NULL);display - ebx
		mov		esi, GetDeviceCaps(ebx, PLANES);planes - esi
		GetDeviceCaps(ebx, BITSPIXEL);bitcnt - edi
		imul	eax, esi
		mov		edi, eax
		DeleteDC(ebx)
		mov		image, CreateBitmap(BitmapWidth, BitmapHeight, esi, edi, &BitmapSegments2)
		mov		buttDC, CreateCompatibleDC(NULL)
		mov		tmpHGDIOBJ2, SelectObject(buttDC, image)
		.for (edi=0, ebx=0: edi<BitmapHeight: edi++);y=edi
			.for (esi=0: esi<BitmapWidth: esi++);x=esi
				;if (BitmapSegments[ny+x/8] & 1<<(7-x%8))
				mov		eax, esi
				and		eax, 111b	;=x%8;
				mov		cl, 7
				sub		cl, al
				mov		al, 1
				shl		al, cl
				mov		edx, esi
				shr		edx, 3		;=x/8;
				mov		ecx, bk_color_indicator
				.if (BitmapSegments[ebx+edx] & al)
					mov		ecx, color_indicator_hi
				.endif
				SetPixelV(buttDC, esi, edi, ecx)
			.endfor
			add		ebx, (BitmapWidth-1)/8+1
		.endfor
		;//создать битмапы цифр
		.for (edi = 0: edi<16: edi++)
			mov		bmNumbers[edi*4], CreateCompatibleBitmap(buttDC, Segment7_sWidth, Segment7_sHeight)
			mov		imageDC0, CreateCompatibleDC(NULL)
			mov		tmpHGDIOBJ0, SelectObject(imageDC0, bmNumbers[edi*4])
			;//фон цифры
			StretchBlt(imageDC0, 0, 0, Segment7_sWidth, Segment7_sHeight, buttDC, Segment7_fon_x, Segment7_fon_y, 1, 1, SRCCOPY)
			;//сегменты цифры
			ASSUME	esi:ptr sBitMapAtlas
			.for (bl=Segment7.segments7[edi], esi= offset Segment7.segm[0]: bl: esi+=sizeof sBitMapAtlas);bl - segments
				shr		bl, 1
				.if (carry?)
					BitBlt(imageDC0, [esi].pos.x, [esi].pos.y, [esi].iWidth, [esi].iHeight, buttDC, [esi].atl.x, [esi].atl.y, SRCCOPY)
				.endif
			.endfor
			ASSUME	esi:nothing
			SelectObject(imageDC0, tmpHGDIOBJ0)
			DeleteDC(imageDC0)
		.endfor
		;//фон индикатора
		mov		bmTemp, CreateCompatibleBitmap(buttDC, IndicatorWidth, IndicatorHeight)
		mov		ebx, CreateCompatibleDC(NULL);imageDC:HDC=ebx
		mov		tmpHGDIOBJ1, SelectObject(ebx, bmTemp)
		StretchBlt(ebx, 0, 0, IndicatorWidth, IndicatorHeight, buttDC, Segment7_fon_x, Segment7_fon_y, 1,1, SRCCOPY)
		;//рисуем двоеточие с точками прямо на фоне индикатора
		pos_x_colon		= disp_x+Segment7_sWidth*2+colon_x
		step_x_colon	= Segment7_sWidth*2+colon_sWidth
		mov		edi, pos_x_colon	;x
		.repeat
			pos_y_colon		= disp_y+colon_y1
			step_y_colon	= colon_y2-colon_y1
			mov		esi, pos_y_colon	;y
			.repeat
				BitBlt(ebx, edi, esi, Segment7_dp_rWidth, Segment7_dp_rHeight, buttDC, Segment7_dp_rx, Segment7_dp_ry, SRCCOPY)
				add		esi, step_y_colon
			.until (esi>pos_y_colon+step_y_colon)
			add		edi, step_x_colon
		.until (edi>pos_x_colon+step_x_colon)
		SendMessage(hIndicator, STM_SETIMAGE, IMAGE_BITMAP, bmTemp)
		SelectObject(ebx, tmpHGDIOBJ1)
		DeleteDC(ebx)
		SelectObject(buttDC, tmpHGDIOBJ2)
		DeleteDC(buttDC)
		DeleteObject(image)
		;------------------------------------------
		UpdateTime()
		SetTimer(hWnd, TIMER_ID, 1000, NULL)
	.elseif (uMsg == WM_SETCURSOR)
		;wmEvent = HIWORD(lParam) & 0xFF;
		mov		edx, lParam
		shr		edx, 16	
		.if (dl==1)	;//на что-то нажали
			mov		eax, wParam	;focus
			.if (hBtnMinimi==eax)				;//сворачиваем
				ShowWindow(hWnd, SW_MINIMIZE)
			.elseif (hBtnClose==eax)			;//закрываем
				DestroyWindow(hWnd)
			.endif
		.endif
	.else
		DefWindowProc(hWnd, uMsg, wParam, lParam)
		;//перемещаем форму за любую часть!
		.if (uMsg == WM_NCHITTEST && eax == HTCLIENT)
			mov		eax, HTCAPTION
		.endif
		jmp		EXIT
	.endif
	xor		eax, eax
EXIT:
	ret
WndProc endp

main_startup_Win32_END